/*
	 from Avram K. Tetewsky, atetewsky@draper.com
	 617-258-1287 voice, 617-258-4444 fax.   home 617-784-2845
	 draper laboratory or charles stark draper Laboratory, 
	 555 Technology Square MS53, 
	 Cambridge Mass 02139.
	 "Document unto others as you would document onto yourself" a tetewsky 1987
	 "How did G-D created the world in 6 days? -- no documenation" a tetewsky 1987
	 (c) 1993
 *
 * file: LVCCB1.C  Compile vs Inter benchmark
   date_created:  12-15-93
   date_modified: 12-15-93
 *                
 */
#define TEST_HARNESS 0
#define NN1          4001
#define NN2          4001

/*
 * typedefs and includes
 */
#if( TEST_HARNESS == 1)
/* needed C interfaces */
   #include <stdio.h>
   #include <stdlib.h>
   #include <math.h>
   #include "FAKELV1.H"
#else   
   #include "EXTCODE.H"
#endif
#include "LVCCB1.H"
#include "VERBOSE.H"
/*
 * prototypes
 */

#if(TEST_HARNESS==1)


main(int argc,char **argv)
begin_code

 int32    nn1,nn2;
 float64  xx1,xx2,xx3,xx4,xx5,xx6,xx1a,xx2a;
 int32    ierr;

  nn1        =  NN1;
  nn2        =  NN2;
  printf(" LVCCB1 NN1=%d NN2=%d NN1*NN2 = %d \n",NN1,NN2,NN1*NN2);
  CINRun(
		 &nn1,
		 &nn2,
		 &xx1,
		 &xx2,      
		 &xx3,      
		 &xx4,      
		 &xx5,      
		 &xx6,  
		 &xx1a,  
		 &xx2a,  
		 &ierr );   
  printf(" xx1=%+15.7e xx2=%+15.7e xx3=%+15.7e\n",xx1,xx2,xx3);
  printf(" xx4=%+15.7e xx5=%+15.7e xx6=%+15.7e\n",xx4,xx5,xx6);
  printf(" x1a=%+15.7e x2a=%+15.7e ierr=%d \n",xx1a,xx2a,ierr);

end_code
#endif


CIN MgErr CINInit(void)  {return noErr;}
CIN MgErr CINDispose(void) {return noErr;}
CIN MgErr CINAbort(void) {return noErr;}
CIN MgErr CINRun(
		 int32    *nn1,
		 int32    *nn2,
		 float64  *xx1,
		 float64  *xx2,      
		 float64  *xx3,      
		 float64  *xx4,      
		 float64  *xx5,      
		 float64  *xx6,  
		 float64  *xx1a,  
		 float64  *xx2a,  
		 int32    *ierr )   

begin_code
    int32   n1,n2,ii,jj;
    float64 xii,xjj,x1,x2,x3,x4,x5,x6,x1a,x2a,xpy,xty;
    *ierr=0;
    x5=0.0;x6=0.0;
    n1 = *nn1; n2 = *nn2;
    for(ii=0;ii<n1;ii++) begin_for
	xii=ii;
	for(jj=0;jj<n2;jj++) begin_for
	  xjj=jj;
	  xpy = xii+xjj;
	  xty = xii*xjj;
	  x1  = sin(xpy);
	  if( xty < 0.0) then_part
	     *ierr += 1;
	  end_then
	  x2  = sqrt(xty);
	  x3  = (xii+1)/(xjj+1);
	  if( xty <= 0.0) then_part
	       x2a = x2;
	  end_then
	  else else_part
	       x2a  = -x2;
	  end_else
	  if( jj % 100 == 0 ) then_part
	      x1a = x1;
	  end_then
	  else else_part
	      x1a  = -x1;
	  end_else
	  x4 = x1a+x2a;
	  x5 += 1.0;
	  x6 += x1a;
	end_for
    end_for
    *xx1 = x1;
    *xx2 = x2;
    *xx3 = x3;
    *xx4 = x4;
    *xx5 = x5;
    *xx6 = x6;
    *xx1a = x1a;
    *xx2a = x2a;
    return noErr;
end_code

CIN MgErr CINLoad(RsrcFile rf) {return noErr;}
CIN MgErr CINUnload(void) {return noErr;}
CIN MgErr CINSave(RsrcFile rf) {return noErr;}


